
;INT 1Ah based time of day
;by DednDave Jan, 2010
;this one has the bugs fixed ;)

;---------------------------------------------------------------------------------

        .MODEL  SMALL
        .STACK  512

;---------------------------------------------------------------------------------

        .DATA

TickLo  dw 0

Hours   db '00:00:00.00',0

ExitMsg db 'Press Esc to Exit',0

;---------------------------------------------------------------------------------

        .CODE

_main   PROC    FAR

;set video mode 3 - clear screen

        mov     ax,3
        int     10h

;set segment registers

        mov     ax,@DATA
        mov     ds,ax
        mov     ax,0B800h
        mov     es,ax
        cld

;display the exit message

        mov     si,offset ExitMsg
        xor     di,di
        call    Dsply

;round-robin loop

TLoop0: mov     ah,0
        int     1Ah
        cmp     dx,TickLo
        jz      TLoop1

        mov     TickLo,dx
        mov     si,offset Hours
        call    UpdCk
        mov     [si+9],ax
        mov     di,1*80*2
        call    Dsply

TLoop1: mov     ah,1
        int     16h                    ;is there a key ?
        jz      TLoop0                 ;no - continue

        mov     ah,0                   ;yes - read it from the buffer
        int     16h
        cmp     al,1Bh                 ;is it Esc ?
        jnz     TLoop0                 ;no - continue

;terminate program

        mov     ax,4C00h               ;yes - terminate
        int     21h

_main   ENDP

;---------------------------------------------------------------------------------

UpdCk   PROC    NEAR

;update clock string

;CX:DX = INT 1Ah clock tick
;SI = string address

        shl     dx,1                   ;multiply by 2
        rcl     cx,1
        mov     ax,cx
        xchg    ax,dx
        mov     bx,ax
        shl     ax,1                   ;multiply by 9
        rcl     dx,1
        shl     ax,1
        rcl     dx,1
        shl     ax,1
        rcl     dx,1
        add     ax,bx
        adc     dx,cx
        mov     bx,19663
        div     bx                     ;divide 28314702 max by 19663
        mov     cx,60
        push    dx
        xor     dx,dx
        div     cx                     ;divide 1439 max by 60
        call    UAscii
        mov     [si],ax
        mov     ax,dx
        call    UAscii
        mov     [si+3],ax
        pop     ax
        mov     dx,6000
        mul     dx
        div     bx                     ;divide 117972000 max by 19663
        mov     cl,100
        xor     dx,dx
        div     cx                     ;divide 5999 max by 100
        call    UAscii
        mov     [si+6],ax
        mov     ax,dx

UAscii: aam
        or      ax,3030h
        xchg    al,ah
        ret

UpdCk   ENDP

;---------------------------------------------------------------------------------

Dsply   PROC    NEAR

        mov     ah,0Ah                 ;AH = attribute
        jmp short Dsply1

Dsply0: stosw

Dsply1: lodsb
        or      al,al
        jnz     Dsply0

        ret

Dsply   ENDP

;---------------------------------------------------------------------------------

        END     _main

